Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/DataBounds.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/DataBounds.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/DataBounds.cs	(revision 14777)
@@ -0,0 +1,55 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Data;
+  using HeuristicLab.Parameters;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  public class DataBounds : ParameterCollection {
+
+    private const string TrainingParameterName = "Training";
+    private const string TestParameterName = "Test";
+
+    public DataBounds() : this(0, 0, 0, 0) {
+    }
+
+    public DataBounds(int trainingStart, int trainingEnd, int testStart, int testEnd) {
+      Add(new FixedValueParameter<IntRange>(TrainingParameterName, new IntRange(trainingStart, trainingEnd)));
+      Add(new FixedValueParameter<IntRange>(TestParameterName, new IntRange(testStart, testEnd)));
+    }
+
+    [StorableConstructor]
+    public DataBounds(bool deserializing) : base(deserializing) {
+    }
+
+    public DataBounds(DataBounds origin, Cloner cloner) : base(origin, cloner) {
+    }
+
+    public IValueParameter<IntRange> TrainingParameter
+    {
+      get { return (IValueParameter<IntRange>)this[TrainingParameterName]; }
+    }
+
+    public IntRange TrainingRange
+    {
+      get { return TrainingParameter.Value; }
+      set { TrainingParameter.Value = value; }
+    }
+
+    public IValueParameter<IntRange> TestParameter
+    {
+      get { return (IValueParameter<IntRange>)this[TestParameterName]; }
+    }
+
+    public IntRange TestRange
+    {
+      get { return TestParameter.Value; }
+      set { TestParameter.Value = value; }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DataBounds(this, cloner);
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushEncoding.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushEncoding.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushEncoding.cs	(revision 14777)
@@ -3,5 +3,4 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
-  using System.Linq;
 
   using HeuristicLab.Common;
@@ -42,15 +41,10 @@
 
     public static PushProgram MapToPushProgram(this IntegerVector vector, IReadOnlyList<string> enabledExpressions) {
-      //var expressions = vector
-      //  .Select(i => ExpressionTable.GetExpression(enabledExpressions[i]))
-      //  .ToArray();
-
       var expressions = new Expression[vector.Length];
-      for (var i = 0; i < vector.Length; i++)
-      {
+      for (var i = 0; i < vector.Length; i++) {
         expressions[i] = ExpressionTable.GetExpression(enabledExpressions[vector[i]]);
       }
 
-      return new Expressions.PushProgram(expressions);
+      return new PushProgram(expressions);
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushEvaluator.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushEvaluator.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushEvaluator.cs	(revision 14777)
@@ -0,0 +1,80 @@
+﻿using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
+  using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.Core;
+  using HeuristicLab.Optimization;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  public static class PushEvaluator {
+    public static double Evaluate(IPushInterpreter interpreter, PushProgram program, Example example, double worstResult) {
+      interpreter.BooleanStack.Push(example.InputBoolean);
+      interpreter.IntegerStack.Push(example.InputInt);
+      interpreter.FloatStack.Push(example.InputFloat);
+
+      interpreter.Run(program);
+
+      return GetDiff(example.OutputInt, interpreter.IntegerStack, worstResult, LongDiffer)
+           + GetDiff(example.OutputFloat, interpreter.FloatStack, worstResult, DoubleDiffer)
+           + GetDiff(example.OutputBoolean, interpreter.BooleanStack, worstResult, BooleanDiffer);
+    }
+
+    public static double Evaluate(PushProgram program, PushInterpreterPool pool, IRandom random, Data data, int startIndex, int endIndex) {
+      if (endIndex - startIndex <= 0) return default(double);
+      var result = 0d;
+
+      using (var interpreter = pool.Create(random)) {
+        for (var i = startIndex; i < endIndex; i++) {
+          result += Evaluate(interpreter, program, data.Examples[i], data.WorstResult);
+          interpreter.Clear();
+        }
+      }
+
+      return result / (endIndex - startIndex);
+    }
+
+    public static double Evaluate(Individual individual, PushInterpreterPool pool, IRandom random, Data data, int startIndex, int endIndex) {
+      var program = individual.PushProgram(pool.PushGpConfiguration.EnabledExpressions as IReadOnlyList<string>);
+      return Evaluate(program, pool, random, data, startIndex, endIndex);
+    }
+
+    private static double DoubleDiffer(double a, double b) {
+      var result = a - b;
+
+      return result == double.MinValue ? double.MaxValue : Math.Abs(result);
+    }
+
+    private static double LongDiffer(long a, long b) {
+      var result = a - b;
+
+      return result == long.MinValue ? long.MaxValue : Math.Abs(result);
+    }
+
+    private static double BooleanDiffer(bool a, bool b) {
+      return a && b ? 0 : a || b ? 1 : 2;
+    }
+
+    private static double GetDiff<T>(IReadOnlyList<T> estimated, IStack<T> resultStack, double worstResult, Func<T, T, double> differ)
+      where T : IComparable {
+
+      var count = Math.Min(estimated.Count, resultStack.Count);
+      var result = resultStack.Peek(count);
+      var comparableLength = Math.Min(estimated.Count, result.Length);
+      var diff = 0d;
+
+      for (var i = 0; i < comparableLength; i++) {
+        diff += Math.Min(differ(estimated[i], result[0]), worstResult);
+      }
+
+      if (estimated.Count > result.Length) {
+        diff += worstResult * (estimated.Count - comparableLength);
+      }
+
+      return diff;
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14777)
@@ -10,5 +10,8 @@
 
   using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.BenchmarkSuite.Problems;
   using HeuristicLab.Data;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
   using Instances;
@@ -17,17 +20,17 @@
   using Parameters;
   using Persistence.Default.CompositeSerializers.Storable;
-  using Stack;
 
   [StorableClass]
   [Creatable(CreatableAttribute.Categories.GeneticProgrammingProblems, Priority = 180)]
   [Item("Push Problem", "")]
-  public class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding>, IProblemInstanceConsumer<IBenchmarkSuiteDataDescriptor> {
+  public class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding>, IProblemInstanceConsumer<Data> {
     [Storable]
     private readonly PushConfiguration config;
     private PushInterpreterPool pool;
+    private IBenchmarkSuiteDataDescriptor dataDescriptor;
 
     public PushProblem() {
       config = new PushConfiguration();
-      pool = new PushInterpreterPool(10000, 1024, 65536, config);
+      pool = new PushInterpreterPool(10000, 4096, 65536, config);
 
       InitEvents();
@@ -98,20 +101,10 @@
     private const string MaxPointsInRandomInstructionParameterDescription = "MaxPointsInRandomInstruction";
     private const string DataBoundsParameterName = "DataBounds";
+    private const string MaxProgramDepthParameterName = "MaxProgramDepth";
+    private const string MaxProgramDepthParameterDescription = "";
 
     private void InitParameters() {
-      var bounds = new IntMatrix(1, 3, new[] { "Training Start", "Training End | Test Start", "Test End" });
-      bounds.ItemChanged += (s, e) => {
-        if (this.DataDescriptor == null)
-          return;
-
-        var max = this.DataDescriptor.OriginalTestCount + this.DataDescriptor.OriginalTrainingCount - 1;
-        bounds[0, 0] = Math.Min(Math.Max(bounds[0, 0], 0), max);
-        bounds[0, 2] = Math.Max(Math.Min(bounds[0, 2], max), 0);
-        bounds[0, 1] = Math.Min(Math.Max(bounds[0, 0], bounds[0, 1]), bounds[0, 2]);
-      };
-
-      Parameters.Add(new FixedValueParameter<IntMatrix>(
-        DataBoundsParameterName,
-        bounds));
+
+      Parameters.Add(new FixedValueParameter<DataBounds>(DataBoundsParameterName));
 
       Parameters.Add(new FixedValueParameter<IntValue>(
@@ -174,5 +167,13 @@
         new IntValue(config.MaxPointsInRandomExpression)) { Hidden = true });
 
-      Parameters.Add(new ValueParameter<IBenchmarkSuiteDataDescriptor>(DataParameterName, DataParameterDescription));
+      Parameters.Add(
+        new FixedValueParameter<IntValue>(
+          MaxProgramDepthParameterName,
+          MaxProgramDepthParameterDescription,
+          new IntValue(config.MaxDepth)));
+
+      Parameters.Add(new ValueParameter<Data>(
+        DataParameterName,
+        DataParameterDescription));
 
       Encoding.Bounds[0, 0] = 0;
@@ -181,10 +182,10 @@
     }
 
-    public IValueParameter<IntMatrix> DataBoundsParameter
-    {
-      get { return (IValueParameter<IntMatrix>)Parameters[DataBoundsParameterName]; }
-    }
-
-    public IntMatrix DataBounds
+    public IValueParameter<DataBounds> DataBoundsParameter
+    {
+      get { return (IValueParameter<DataBounds>)Parameters[DataBoundsParameterName]; }
+    }
+
+    public DataBounds DataBounds
     {
       get { return DataBoundsParameter.Value; }
@@ -204,10 +205,10 @@
     }
 
-    public IValueParameter<IBenchmarkSuiteDataDescriptor> DataParameter
-    {
-      get { return (IValueParameter<IBenchmarkSuiteDataDescriptor>)Parameters[DataParameterName]; }
-    }
-
-    public IBenchmarkSuiteDataDescriptor DataDescriptor
+    public IValueParameter<Data> DataParameter
+    {
+      get { return (IValueParameter<Data>)Parameters[DataParameterName]; }
+    }
+
+    public Data Data
     {
       get { return DataParameter.Value; }
@@ -217,5 +218,5 @@
     public IValueParameter<IntValue> EvalPushLimitParameter
     {
-      get { return (IValueParameter<IntValue>)this.Parameters[EvalPushLimitParameterName]; }
+      get { return (IValueParameter<IntValue>)Parameters[EvalPushLimitParameterName]; }
     }
 
@@ -227,4 +228,19 @@
         this.EvalPushLimitParameter.Value.Value = value;
         config.EvalPushLimit = value;
+      }
+    }
+
+    public IValueParameter<IntValue> MaxDepthParameter
+    {
+      get { return (IValueParameter<IntValue>)this.Parameters[MaxProgramDepthParameterName]; }
+    }
+
+    public int MaxDepth
+    {
+      get { return config.MaxDepth; }
+      set
+      {
+        this.MaxDepthParameter.Value.Value = value;
+        config.MaxDepth = value;
       }
     }
@@ -394,5 +410,5 @@
       var bestIdx = Array.IndexOf(qualities, bestQuality);
       var bestIndividual = individuals[bestIdx];
-      var solution = new PushSolution(bestIndividual.IntegerVector(), bestQuality, DataDescriptor, random, config);
+      var solution = new PushSolution(bestIndividual.IntegerVector(), bestQuality, Data, random, config, DataBounds.TrainingRange.Start, DataBounds.TrainingRange.End);
 
       if (!results.ContainsKey(bestSolutionResultName)) {
@@ -404,72 +420,33 @@
 
     public override double Evaluate(Individual individual, IRandom random) {
-      if (DataBounds[0, 1] <= 0) return default(double);
-
-      var program = individual.PushProgram(config.EnabledExpressions as IReadOnlyList<string>);
-      var result = 0d;
-
-      using (var interpreter = pool.GetInstance(random)) {
-        for (var i = DataBounds[0, 0]; i < DataBounds[0, 1]; i++) {
-          var example = DataDescriptor.Examples[i];
-
-          interpreter.BooleanStack.Push(example.InputBoolean);
-          interpreter.IntegerStack.Push(example.InputInt);
-          interpreter.FloatStack.Push(example.InputFloat);
-
-          interpreter.Run(program);
-
-          result += GetDiff(example.OutputInt, interpreter.IntegerStack, DataDescriptor.WorstResult, LongDiffer)
-                  + GetDiff(example.OutputFloat, interpreter.FloatStack, DataDescriptor.WorstResult, DoubleDiffer)
-                  + GetDiff(example.OutputBoolean, interpreter.BooleanStack, DataDescriptor.WorstResult, BooleanDiffer);
-
-          interpreter.Clear();
-        }
-      }
-
-      return result / DataBounds[0, 1];
-    }
-
-    private static double DoubleDiffer(double a, double b) {
-      var result = a - b;
-
-      return result == double.MinValue ? double.MaxValue : Math.Abs(result);
-    }
-
-    private static double LongDiffer(long a, long b) {
-      var result = a - b;
-
-      return result == long.MinValue ? long.MaxValue : Math.Abs(result);
-    }
-
-    private static double BooleanDiffer(bool a, bool b) {
-      return a && b ? 0 : a || b ? 1 : 2;
-    }
-
-    private static double GetDiff<T>(IReadOnlyList<T> estimated, IStack<T> resultStack, double worstResult, Func<T, T, double> differ)
-      where T : IComparable {
-
-      var count = Math.Min(estimated.Count, resultStack.Count);
-      var result = resultStack.Peek(count);
-      var comparableLength = Math.Min(estimated.Count, result.Length);
-      var diff = 0d;
-
-      for (var i = 0; i < comparableLength; i++) {
-        diff += Math.Min(differ(estimated[i], result[0]), worstResult);
-      }
-
-      if (estimated.Count > result.Length) {
-        diff += worstResult * (estimated.Count - comparableLength);
-      }
-
-      return diff;
-    }
-
-    public void Load(IBenchmarkSuiteDataDescriptor descriptor) {
-      this.DataDescriptor = descriptor;
-      BestKnownQuality = descriptor.BestResult;
-
-      DataBounds[0, 0] = 0;
-      DataBounds[0, 2] = this.DataDescriptor.OriginalTrainingCount + this.DataDescriptor.OriginalTestCount;
-      DataBounds[0, 1] = this.DataDescriptor.OriginalTrainingCount;
+      return PushEvaluator.Evaluate(individual, pool, random, Data, DataBounds.TrainingRange.Start, DataBounds.TrainingRange.End);
+    }
+
+    public void Load(Data data) {
+      Data = data;
+      BestKnownQuality = data.BestResult;
+      MaxProgramLength = data.MaxSize;
+      EvalPushLimit = data.EvalLimit;
+
+      config.EnabledExpressions = (IList<string>)ExpressionTable.GetEnabledExpressionsByStackTypes((StackTypes)data.EnabledDataTypes);
+
+      // update enabled stack types
+      foreach (var stackType in ExpressionTable.StackTypeToNamesTable.Keys) {
+        var enabledStackExpressions = config.EnabledExpressions.Intersect(ExpressionTable.StackTypeToNamesTable[stackType]);
+        config.SetStack(stackType, enabledStackExpressions.Any());
+      }
+
+      Encoding.Bounds[0, 0] = 0;
+      Encoding.Bounds[0, 1] = config.EnabledExpressions.Count - 1;
+      Encoding.Length = config.MaxPointsInProgram;
+
+      // TODO
+      // data.MaxGenerations
+      // data.ProgEvalBudget
+
+      DataBounds.TrainingRange.Start = 0;
+      DataBounds.TrainingRange.End = Data.OriginalTrainingCount - 1;
+      DataBounds.TestRange.Start = Data.OriginalTrainingCount;
+      DataBounds.TestRange.End = Data.OriginalTrainingCount + Data.OriginalTestCount;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 14777)
@@ -1,11 +1,9 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem {
-  using HeuristicLab.BenchmarkSuite;
+  using HeuristicLab.BenchmarkSuite.Problems;
   using HeuristicLab.Common;
   using HeuristicLab.Core;
   using HeuristicLab.Encodings.IntegerVectorEncoding;
-  using HeuristicLab.Optimization;
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
 
   [StorableClass]
@@ -16,30 +14,37 @@
     public readonly IntegerVector IntegerVector;
     [Storable]
-    public readonly IBenchmarkSuiteDataDescriptor DataDescriptor;
+    public readonly Data Data;
     [Storable]
     public readonly IRandom Random;
     [Storable]
-    public readonly IReadonlyPushConfiguration Config;
+    public readonly IReadOnlyPushConfiguration Config;
+    [Storable]
+    public readonly int DataStart;
+    [Storable]
+    public readonly int DataEnd;
 
-    public PushSolution(IntegerVector integerVector, double quality, IBenchmarkSuiteDataDescriptor dataDescriptor, IRandom random, IReadonlyPushConfiguration config)
+    public PushSolution(IntegerVector integerVector, double quality, Data data, IRandom random, IReadOnlyPushConfiguration config, int dataStart, int dataEnd)
       : base("Solution", "A push solution.") {
       IntegerVector = integerVector;
       Quality = quality;
-      DataDescriptor = dataDescriptor;
+      Data = data;
       Random = random;
       Config = config;
+      DataStart = dataStart;
+      DataEnd = dataEnd;
     }
 
     public PushSolution(PushSolution origin, Cloner cloner) : base(origin, cloner) {
-      IntegerVector = origin.IntegerVector;
+      IntegerVector = cloner.Clone(origin.IntegerVector);
       Quality = origin.Quality;
+      Data = cloner.Clone(origin.Data);
+      Random = cloner.Clone(origin.Random);
+      Config = cloner.Clone(origin.Config);
+      DataStart = origin.DataStart;
+      DataEnd = origin.DataEnd;
     }
 
     [StorableConstructor]
     private PushSolution(bool deserializing) : base(deserializing) { }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-    }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/Simplifier.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/Simplifier.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Simplifier/Simplifier.cs	(revision 14777)
@@ -0,0 +1,42 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Simplifier {
+  using System;
+
+  using Expressions;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Tree;
+
+  public static class Simplifier {
+    private static readonly TreeNode<Expression> NoopNode =
+      new TreeNode<Expression>(ExpressionTable.GetStatelessExpression<CodeNoopExpression>());
+
+    public static PushProgram Simplify(PushProgram program, Func<PushProgram, double> evaluator) {
+      var bestResult = evaluator(program);
+      var tree = program.ToTree();
+      var optimizedTree = RemoveUnnecessaryExpressions(tree, tree, ref bestResult, evaluator);
+
+      return optimizedTree.ToPushProgram(e => !ReferenceEquals(e, NoopNode.Value));
+    }
+
+    private static TreeNode<Expression> RemoveUnnecessaryExpressions(Tree<Expression> program, TreeNode<Expression> node, ref double bestResult, Func<PushProgram, double> evaluator) {
+      for (var i = 0; i < node.Children.Count; i++) {
+        var child = node.Children[i];
+        node.ReplaceNode(i, NoopNode);
+
+        var currentProgram = program.ToPushProgram();
+        var currentResult = evaluator(currentProgram);
+
+        if (currentResult <= bestResult) {
+          bestResult = currentResult;
+        } else if (child.Value.IsProgram) {
+          node.ReplaceNode(i, child);
+          var subProgram = RemoveUnnecessaryExpressions(program, child, ref bestResult, evaluator);
+          node.ReplaceNode(i, subProgram);
+        } else {
+          node.ReplaceNode(i, child);
+        }
+      }
+
+      return node;
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IStack.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IStack.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/IStack.cs	(revision 14777)
@@ -22,9 +22,9 @@
 
     void Push(T item);
+    void Push(T item1, T item2);
+    void Push(T item1, T item2, T item3);
+    void Push(T item1, T item2, T item3, T item4);
 
-    void Push(params T[] items);
-    void ReversePush(params T[] items);
-
-    void Push(IReadOnlyList<T> items);
+    void Push(IReadOnlyList<T> items, int startIndex = 0);
 
     T Peek();
@@ -35,8 +35,4 @@
 
     void Insert(int index, T item);
-
-    void Insert(int index, params T[] items);
-
-    void Insert(int index, IEnumerable<T> items);
 
     T ReverseElementAt(int offset);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PushStack.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PushStack.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/PushStack.cs	(revision 14777)
@@ -33,5 +33,5 @@
       get
       {
-        return this.data.Capacity;
+        return data.Capacity;
       }
     }
@@ -41,5 +41,5 @@
       get
       {
-        return this.data[this.Count - 1];
+        return data[Count - 1];
       }
     }
@@ -49,5 +49,5 @@
       get
       {
-        return this.Count > 0 ? this.data[this.Count - 1] : default(T);
+        return Count > 0 ? Top : default(T);
       }
     }
@@ -57,5 +57,5 @@
       get
       {
-        return this.data[0];
+        return data[0];
       }
     }
@@ -65,5 +65,5 @@
       get
       {
-        return this.Count > 0 ? this.data[0] : default(T);
+        return Count > 0 ? Bottom : default(T);
       }
     }
@@ -73,5 +73,5 @@
       get
       {
-        return this.data.Count;
+        return data.Count;
       }
     }
@@ -81,5 +81,5 @@
       get
       {
-        return this.Count == 0;
+        return Count == 0;
       }
     }
@@ -94,33 +94,33 @@
 
     public void Add(T item) {
-      this.Push(item);
+      Push(item);
     }
 
     public void Clear() {
-      this.data.Clear();
+      data.Clear();
     }
 
     public bool Contains(T item) {
-      return this.data.Contains(item);
+      return data.Contains(item);
     }
 
     public void CopyTo(T[] array, int arrayIndex) {
-      this.data.CopyTo(array, arrayIndex);
+      data.CopyTo(array, arrayIndex);
     }
 
     public IEnumerator<T> GetEnumerator() {
-      return this.data.GetEnumerator();
+      return data.GetEnumerator();
     }
 
     public T ElementAt(int index) {
-      return this.data[index];
+      return data[index];
     }
 
     public T ReverseElementAt(int offset) {
-      return this.data[this.data.Count - 1 - offset];
+      return data[data.Count - 1 - offset];
     }
 
     public void SetTop(T value) {
-      this.data[this.Count - 1] = value;
+      data[Count - 1] = value;
     }
 
@@ -129,32 +129,32 @@
       get
       {
-        return this.data[key];
+        return data[key];
       }
       set
       {
-        this.data[key] = value;
+        data[key] = value;
       }
     }
 
     public void Swap(int count) {
-      var top = this.Top;
-      var bottomIndex = this.Count - count;
-
-      for (var i = this.Count - 1; i > bottomIndex; i--) this.data[i] = this.data[i - 1];
-
-      this.data[bottomIndex] = top;
+      var top = Top;
+      var bottomIndex = Count - count;
+
+      for (var i = Count - 1; i > bottomIndex; i--) data[i] = data[i - 1];
+
+      data[bottomIndex] = top;
     }
 
     public void Yank(int index) {
-      if (index == this.Count - 1) return;
-
-      var item = this.ElementAt(index);
-      this.data.RemoveAt(index);
-      this.data.Add(item);
+      if (index == Count - 1) return;
+
+      var item = ElementAt(index);
+      data.RemoveAt(index);
+      data.Add(item);
     }
 
     public T Pop() {
-      var value = this.data[this.Count - 1];
-      this.data.RemoveAt(this.Count - 1);
+      var value = data[Count - 1];
+      data.RemoveAt(Count - 1);
 
       return value;
@@ -163,5 +163,5 @@
     public T[] Pop(int count) {
       var items = Peek(count);
-      this.Remove(count);
+      Remove(count);
 
       return items;
@@ -173,8 +173,8 @@
 
     public T[] Peek(int count) {
-      var startIndex = this.Count - count;
+      var startIndex = Count - count;
 
       var items = new T[count];
-      this.data.CopyTo(startIndex, items, 0, count);
+      data.CopyTo(startIndex, items, 0, count);
 
       return items;
@@ -184,5 +184,29 @@
       if (!IsEnabled) return;
 
-      this.data.Add(item);
+      data.Add(item);
+    }
+
+    public void Push(T item1, T item2) {
+      if (!IsEnabled) return;
+
+      data.Add(item1);
+      data.Add(item2);
+    }
+
+    public void Push(T item1, T item2, T item3) {
+      if (!IsEnabled) return;
+
+      data.Add(item1);
+      data.Add(item2);
+      data.Add(item3);
+    }
+
+    public void Push(T item1, T item2, T item3, T item4) {
+      if (!IsEnabled) return;
+
+      data.Add(item1);
+      data.Add(item2);
+      data.Add(item3);
+      data.Add(item4);
     }
 
@@ -190,29 +214,17 @@
       if (!IsEnabled) return;
 
-      var startIndex = this.Count - count;
+      var startIndex = Count - count;
       var items = new T[count];
 
-      this.data.CopyTo(startIndex, items, 0, count);
-      this.Remove(count - 1);
-
-      this.data[this.Count - 1] = templateFunc(items);
-    }
-
-    public void Push(params T[] items) {
-      if (!IsEnabled) return;
-
-      for (var i = 0; i < items.Length; i++) this.data.Add(items[i]);
-      //this.data.AddRange(items);
-    }
-
-    public void ReversePush(params T[] items) {
-      for (var i = items.Length - 1; i >= 0; i--) this.data.Add(items[i]);
-    }
-
-    public void Push(IReadOnlyList<T> items) {
-      if (!IsEnabled) return;
-
-      for (var i = 0; i < items.Count; i++) this.data.Add(items[i]);
-      //this.data.AddRange(items);
+      data.CopyTo(startIndex, items, 0, count);
+      Remove(count - 1);
+
+      data[Count - 1] = templateFunc(items);
+    }
+
+    public void Push(IReadOnlyList<T> items, int startIndex = 0) {
+      if (!IsEnabled) return;
+
+      for (var i = startIndex; i < items.Count; i++) data.Add(items[i]);
     }
 
@@ -220,47 +232,30 @@
       if (!IsEnabled) return;
 
-      this.data.Insert(index, item);
-    }
-
-    public void Insert(int index, params T[] items) {
-      if (!IsEnabled) return;
-
-      this.data.InsertRange(index, items);
-    }
-
-    public void Insert(int index, IEnumerable<T> items) {
-      if (!IsEnabled) return;
-
-      this.data.InsertRange(index, items);
+      data.Insert(index, item);
     }
 
     public bool Remove(T item) {
-      var index = this.Count - 1;
-      if ((this.Count > 0) && this.data[index].Equals(item)) {
-        this.data.RemoveAt(index);
-        return true;
-      }
-      return false;
+      return this.data.Remove(item);
     }
 
     public void RemoveTop() {
-      this.data.RemoveAt(this.Count - 1);
+      data.RemoveAt(Count - 1);
     }
 
     public void Remove(int count) {
-      for (var i = 0; i < count; i++) this.data.RemoveAt(this.Count - 1);
+      this.data.RemoveRange(this.Count - count, count);
     }
 
     public void RemoveAt(int index) {
-      this.data.RemoveAt(index);
+      data.RemoveAt(index);
     }
 
     public void RemoveAt(int index, int count) {
-      this.data.RemoveRange(index, count);
+      data.RemoveRange(index, count);
     }
 
     public bool TryPop(out T item) {
-      if (this.Count > 0) {
-        item = this.Pop();
+      if (Count > 0) {
+        item = Pop();
         return true;
       }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/StackTypes.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/StackTypes.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Stack/StackTypes.cs	(revision 14777)
@@ -0,0 +1,16 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Stack {
+  using System;
+
+  [Flags]
+  public enum StackTypes : ushort {
+    None = 0x00, // Required to specify expression dependencies
+    Integer = 0x02,
+    Float = 0x04,
+    Char = 0x08,
+    String = 0x10,
+    Boolean = 0x20,
+    Name = 0x40,
+    Code = 0x80,
+    Exec = 0x100,
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/ExpressionSelectionView.cs	(revision 14777)
@@ -43,13 +43,13 @@
 
     private void ExpressionsTreeViewAfterCheck(object sender, TreeViewEventArgs e) {
-      var isStackNode = e.Node.Tag is StackType;
+      var isStackNode = e.Node.Tag is StackTypes;
 
       if (isStackNode) {
         if (e.Node.Checked) {
-          Content.EnableStack((StackType)e.Node.Tag);
+          Content.EnableStack((StackTypes)e.Node.Tag);
           foreach (var subNode in e.Node.Nodes.Cast<TreeNode>())
             subNode.Checked = true;
         } else {
-          Content.DisableStack((StackType)e.Node.Tag);
+          Content.DisableStack((StackTypes)e.Node.Tag);
           foreach (var subNode in e.Node.Nodes.Cast<TreeNode>())
             subNode.Checked = false;
@@ -71,4 +71,6 @@
       }
 
+      this.nameTextBox.Text = "Push Expression Selection";
+
       var treeNodes = GetTreeNodes(Content.EnabledExpressions).ToArray();
       expressionsTreeView.Nodes.AddRange(treeNodes);
@@ -79,5 +81,5 @@
         var stackTreeNode = new TreeNode {
           Tag = stackType,
-          Text = Enum.GetName(typeof(StackType), stackType),
+          Text = Enum.GetName(typeof(StackTypes), stackType),
         };
 
